using System;
using System.Data;
using System.Collections;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.CMSHelper;
using TreeNode = CMS.TreeEngine.TreeNode;

public partial class CMSWebParts_CommunityServices_SocialBookmarking : CMSAbstractWebPart
{
    #region "Private variables"

    /// <summary>
    /// Hashtable which contains info about bookmark services
    /// </summary>
    private static readonly Hashtable bookmarkServices = new Hashtable();

    #endregion


    #region "Services properties"

    /// <summary>
    /// Google bookmarks service.
    /// </summary>
    public bool GoogleBookmarks
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("GoogleBookmarks"), false);
        }
        set
        {
            SetValue("GoogleBookmarks", value);
        }

    }


    /// <summary>
    /// Delicious service.
    /// </summary>
    public bool Delicious
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Delicious"), false);
        }
        set
        {
            SetValue("Delicious", value);
        }
    }


    /// <summary>
    /// Digg service.
    /// </summary>
    public bool Digg
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Digg"), false);
        }
        set
        {
            SetValue("Digg", value);
        }
    }


    /// <summary>
    /// MySpace service.
    /// </summary>
    public bool MySpace
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("MySpace"), false);
        }
        set
        {
            SetValue("MySpace", value);
        }
    }


    /// <summary>
    /// Facebook service.
    /// </summary>
    public bool FaceBook
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("FaceBook"), false);
        }
        set
        {
            SetValue("FaceBook", value);
        }
    }


    /// <summary>
    /// Furl service.
    /// </summary>
    public bool Furl
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Furl"), false);
        }
        set
        {
            SetValue("Furl", value);
        }
    }


    /// <summary>
    /// YahooMyWeb service.
    /// </summary>
    public bool YahooMyWeb
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("YahooMyWeb"), false);
        }
        set
        {
            SetValue("YahooMyWeb", value);
        }
    }


    /// <summary>
    /// Stumble upon service.
    /// </summary>
    public bool StumbleUpon
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("StumbleUpon"), false);
        }
        set
        {
            SetValue("StumbleUpon", value);
        }
    }


    /// <summary>
    /// Reddit service.
    /// </summary>
    public bool Reddit
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Reddit"), false);
        }
        set
        {
            SetValue("Reddit", value);
        }
    }


    /// <summary>
    /// Newsvine service.
    /// </summary>
    public bool Newsvine
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Newsvine"), false);
        }
        set
        {
            SetValue("Newsvine", value);
        }
    }


    /// <summary>
    /// Live service.
    /// </summary>
    public bool Live
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Live"), false);
        }
        set
        {
            SetValue("Live", value);
        }
    }


    /// <summary>
    /// Technorati service.
    /// </summary>
    public bool Technorati
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Technorati"), false);
        }
        set
        {
            SetValue("Technorati", value);
        }
    }


    /// <summary>
    /// Twitter service.
    /// </summary>
    public bool Twitter
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Twitter"), false);
        }
        set
        {
            SetValue("Twitter", value);
        }
    }


    /// <summary>
    /// YahooBookmarks
    /// </summary>
    public bool YahooBookmarks
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("YahooBookmarks"), false);
        }
        set
        {
            SetValue("YahooBookmarks", value);
        }
    }


    /// <summary>
    /// MyAOL service.
    /// </summary>
    public bool MyAOL
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("MyAOL"), false);
        }
        set
        {
            SetValue("MyAOL", value);
        }
    }


    /// <summary>
    /// Ask service.
    /// </summary>
    public bool Ask
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Ask"), false);
        }
        set
        {
            SetValue("Ask", value);
        }
    }


    /// <summary>
    /// Fark service.
    /// </summary>
    public bool Fark
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Fark"), false);
        }
        set
        {
            SetValue("Fark", value);
        }
    }


    /// <summary>
    /// Slashdot service.
    /// </summary>
    public bool Slashdot
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Slashdot"), false);
        }
        set
        {
            SetValue("Slashdot", value);
        }
    }


    /// <summary>
    /// Mixx service.
    /// </summary>
    public bool Mixx
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Mixx"), false);
        }
        set
        {
            SetValue("Mixx", value);
        }
    }


    /// <summary>
    /// Multiply service.
    /// </summary>
    public bool Multiply
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Multiply"), false);
        }
        set
        {
            SetValue("Multiply", value);
        }
    }


    /// <summary>
    /// Simply service.
    /// </summary>
    public bool Simpy
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Simpy"), false);
        }
        set
        {
            SetValue("Simpy", value);
        }
    }


    /// <summary>
    /// Blogmarks service.
    /// </summary>
    public bool Blogmarks
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Blogmarks"), false);
        }
        set
        {
            SetValue("Blogmarks", value);
        }
    }


    /// <summary>
    /// Diigo service.
    /// </summary>
    public bool Diigo
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Diigo"), false);
        }
        set
        {
            SetValue("Diigo", value);
        }
    }


    /// <summary>
    /// Daves service.
    /// </summary>
    public bool Faves
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Faves"), false);
        }
        set
        {
            SetValue("Faves", value);
        }
    }


    /// <summary>
    /// Spurl service.
    /// </summary>
    public bool Spurl
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Spurl"), false);
        }
        set
        {
            SetValue("Spurl", value);
        }
    }


    /// <summary>
    /// Link-a-gogo service.
    /// </summary>
    public bool LinkAGogo
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("LinkAGogo"), false);
        }
        set
        {
            SetValue("LinkAGogo", value);
        }
    }


    /// <summary>
    /// MisterWong service. 
    /// </summary>
    public bool MisterWong
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("MisterWong"), false);
        }
        set
        {
            SetValue("MisterWong", value);
        }
    }


    /// <summary>
    /// Backflip service.
    /// </summary>
    public bool Backflip
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Backflip"), false);
        }
        set
        {
            SetValue("Backflip", value);
        }
    }


    /// <summary>
    /// Magnolia service.
    /// </summary>
    public bool Magnolia
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Magnolia"), false);
        }
        set
        {
            SetValue("Magnolia", value);
        }
    }


    /// <summary>
    /// Seganlo service.
    /// </summary>
    public bool Segnalo
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("Segnalo"), false);
        }
        set
        {
            SetValue("Segnalo", value);
        }
    }

    #endregion


    #region "Other properties"

    /// <summary>
    /// Title (text before bookmarks).
    /// </summary>
    public string Title
    {
        get
        {
            return ValidationHelper.GetString(GetValue("Title"), "");
        }
        set
        {
            SetValue("Title", value);
        }
    }


    /// <summary>
    /// Separator.
    /// </summary>
    public string Separator
    {
        get
        {
            return ValidationHelper.GetString(GetValue("Separator"), "");
        }
        set
        {
            SetValue("Separator", value);
        }
    }


    /// <summary>
    /// Title CSS class.
    /// </summary>
    public string TitleClass
    {
        get
        {
            return ValidationHelper.GetString(GetValue("TitleClass"), "");
        }
        set
        {
            SetValue("TitleClass", value);
        }
    }


    /// <summary>
    /// If true, links are opened in new window.
    /// </summary>
    public bool ShowInNewWindow
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("ShowInNewWindow"), false);
        }
        set
        {
            SetValue("ShowInNewWindow", value);
        }
    }

    #endregion


    #region "Events"

    /// <summary>
    /// Page load
    /// </summary>    
    protected void Page_Load(object sender, EventArgs e)
    {
    }


    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Reloads data
    /// </summary>
    public override void ReloadData()
    {
        base.ReloadData();
        SetupControl();
    }

    #endregion


    #region "Methods"

    /// <summary>
    /// Fill hashtables 
    /// </summary>
    private static void FillHashTable()
    {
        if (bookmarkServices.Count == 0)
        {
            lock (bookmarkServices)
            {
                // Each record has display name, url, url to book and title
                bookmarkServices["GoogleBookmarks"] = new string[] { "Google Bookmarks", "http://www.google.com/bookmarks/mark?op=add&amp;bkmk=", "&amp;title=" };
                bookmarkServices["Delicious"] = new string[] { "Delicious", "http://delicious.com/save?jump=yes&amp;noui&amp;v=4&amp;url=", "&amp;title=" };
                bookmarkServices["Digg"] = new string[] { "Digg", "http://digg.com/submit/?url=", "&amp;title=" };
                bookmarkServices["MySpace"] = new string[] { "MySpace", "http://www.myspace.com/Modules/PostTo/Pages/?u=", "&amp;t=" };
                bookmarkServices["FaceBook"] = new string[] { "Facebook", "http://www.facebook.com/sharer.php?u=", "&amp;t=" };
                bookmarkServices["Furl"] = new string[] { "Furl", "http://www.furl.net/savedialog.jsp?p=1&amp;u=", "&amp;t=" };
                bookmarkServices["YahooMyWeb"] = new string[] { "Yahoo MyWeb", "http://myweb2.search.yahoo.com/myresults/bookmarklet?u=", "&amp;t=" };
                bookmarkServices["StumbleUpon"] = new string[] { "StumbleUpon", "http://www.stumbleupon.com/submit?url=", "&amp;title=" };
                bookmarkServices["Reddit"] = new string[] { "Reddit", "http://www.reddit.com/submit?url=", "&amp;title=" };
                bookmarkServices["Newsvine"] = new string[] { "Newsvine", "http://www.newsvine.com/_tools/seed&amp;save?u=", "&amp;h=" };
                bookmarkServices["Live"] = new string[] { "Live", "https://favorites.live.com/quickadd.aspx?marklet=1&amp;url=", "&amp;title=" };
                bookmarkServices["Technorati"] = new string[] { "Terchnorati", "http://technorati.com/faves/?add=", "&amp;title=" };
                bookmarkServices["Twitter"] = new string[] { "Twitter", "http://twitter.com/share?url=", "&text=" };
                bookmarkServices["YahooBookmarks"] = new string[] { "Yahoo Bookmarks", "http://bookmarks.yahoo.com/toolbar/savebm?u=", "&amp;t=" };
                bookmarkServices["MyAOL"] = new string[] { "MyAOL", "http://favorites.my.aol.com/ffclient/webroot/0.4.5/src/html/addBookmarkDialog.html?url=", "&amp;title=" };
                bookmarkServices["Ask"] = new string[] { "Ask", "http://myjeeves.ask.com/mysearch/BookmarkIt?v=1.2&amp;t=webpages&amp;url=", "&amp;title=" };
                bookmarkServices["Fark"] = new string[] { "Fark", "http://cgi.fark.com/cgi/fark/submit.pl?new_url=", "&amp;new_comment=" };
                bookmarkServices["Slashdot"] = new string[] { "Slashdot", "http://slashdot.org/bookmark.pl?url=", "&amp;title=" };
                bookmarkServices["Mixx"] = new string[] { "Mixx", "http://www.mixx.com/submit?page_url=", "&amp;title=" };
                bookmarkServices["Multiply"] = new string[] { "Multiply", "http://multiply.com/gus/journal/compose/?url=", "&amp;subject=" };
                bookmarkServices["Simpy"] = new string[] { "Simpy", "http://www.simpy.com/simpy/LinkAdd.do?href=", "&amp;note=" };
                bookmarkServices["Blogmarks"] = new string[] { "Blogmarks", "http://blogmarks.net/my/new.php?url=", "&amp;title=" };
                bookmarkServices["Diigo"] = new string[] { "Diigo", "http://www.diigo.com/post?url=", "&amp;title=" };
                bookmarkServices["Faves"] = new string[] { "Faves", "http://faves.com/Authoring.aspx?u=", "&amp;t=" };
                bookmarkServices["Spurl"] = new string[] { "Spurl", "http://www.spurl.net/spurl.php?url=", "&amp;title=" };
                bookmarkServices["LinkAGogo"] = new string[] { "Link-a-Gogo", "http://www.linkagogo.com/go/AddNoPopup?url=", "&amp;title=" };
                bookmarkServices["MisterWong"] = new string[] { "Mister Wong", "http://www.mister-wong.com/index.php?action=addurl&amp;bm_url=", "&amp;bm_description=" };
                bookmarkServices["Backflip"] = new string[] { "Backflip", "http://www.backflip.com/add_page_pop.ihtml?url=", "&amp;title=" };
                bookmarkServices["Segnalo"] = new string[] { "Segnalo", "http://segnalo.alice.it/post.html.php?url=", "&amp;title=" };
            }
        }
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    public void SetupControl()
    {
        ltlIcons.Text = "";

        // Fill hashtable with info about all bookmark services
        FillHashTable();

        // Resolve path of images
        string imagesPath = ResolveUrl("SocialBookmarking_files");

        // Get current document
        TreeNode node = CMSContext.CurrentDocument;
        if (node != null)
        {
            // Get url of current document
            string liveUrl = UrlHelper.CurrentURL;
            liveUrl = UrlHelper.GetAbsoluteUrl(liveUrl);

            // Encode url
            liveUrl = Server.UrlEncode(liveUrl);

            // Prepare target
            string target = ShowInNewWindow ? "target=\"_blank\"" : "";

            string[] bookmarkInfo = new string[4];

            // Get all keys from hashtable
            object[] keys = new object[bookmarkServices.Count];
            bookmarkServices.Keys.CopyTo(keys, 0);

            // Loop thru all items in hashtable
            for (int i = 0; i != keys.Length; i++)
            {
                // Get structure
                bookmarkInfo = (string[])bookmarkServices[keys[i]];
                string currentService = keys[i].ToString();
                if (bookmarkInfo.Length != 0)
                {
                    // If current service is enabled generate html code
                    if (ValidationHelper.GetBoolean(GetValue(currentService), false))
                    {
                        if (!string.IsNullOrEmpty(ltlIcons.Text))
                        {
                            ltlIcons.Text += Separator;
                        }
                        ltlIcons.Text += "<a href=\"" + bookmarkInfo[1] + liveUrl + bookmarkInfo[2] + Server.UrlEncode(node.DocumentName) + "\" title=\"" + ResHelper.GetString("addtobook.addto") + " " + bookmarkInfo[0] + "\" " + target + " ><img src=\"" + imagesPath + "/" + currentService.ToLower() + ".gif" + "\" alt=\"" + ResHelper.GetString("addtobook.addto") + " " + bookmarkInfo[0] + "\" style=\"border-style:none;\" /></a>";
                    }
                }
            }

            // If at least one bookmarking service was checked show title
            if (!string.IsNullOrEmpty(ltlIcons.Text))
            {
                if (!string.IsNullOrEmpty(TitleClass))
                {
                    ltlIcons.Text = "<span class=\"" + TitleClass + "\">" + Title + "</span>" + ltlIcons.Text;
                }
                else
                {
                    ltlIcons.Text = Title + ltlIcons.Text;
                }
            }
        }
    }

    #endregion
}
